Index: trunk/source/geometry/navigation/src/G4Navigator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4Navigator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4Navigator.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4Navigator.cc,v 1.39 2009/05/08 06:47:32 tnikitin Exp $
+// $Id: G4Navigator.cc,v 1.46 2010/11/15 14:03:27 gcosmo Exp $
 // GEANT4 tag $ Name:  $
 // 
@@ -47,5 +47,5 @@
 G4Navigator::G4Navigator()
   : fWasLimitedByGeometry(false), fVerbose(0),
-    fTopPhysical(0), fCheck(false), fPushed(false)
+    fTopPhysical(0), fCheck(false), fPushed(false), fWarnPush(true)
 {
   fActive= false; 
@@ -128,7 +128,7 @@
 
 #ifdef G4VERBOSE
-  G4int oldcoutPrec = G4cout.precision(8);
   if( fVerbose > 2 )
   {
+    G4int oldcoutPrec = G4cout.precision(8);
     G4cout << "*** G4Navigator::LocateGlobalPointAndSetup: ***" << G4endl; 
     G4cout << "    Called with arguments: " << G4endl
@@ -140,4 +140,5 @@
       PrintState();
     }
+    G4cout.precision(oldcoutPrec);
   }
 #endif
@@ -195,5 +196,5 @@
               break;
             case kParameterised:
-              if( fBlockedPhysicalVolume->GetRegularStructureId() != 1 )
+              if( fBlockedPhysicalVolume->GetRegularStructureId() == 0 )
               {
                 G4VSolid *pSolid;
@@ -360,4 +361,5 @@
     //
     targetPhysical = fHistory.GetTopVolume();
+    if (!targetPhysical) { break; }
     targetLogical = targetPhysical->GetLogicalVolume();
     switch( CharacteriseDaughters(targetLogical) )
@@ -452,10 +454,7 @@
   if( fVerbose == 4 )
   {
-    G4cout.precision(6);
+    G4int oldcoutPrec = G4cout.precision(8);
     G4String curPhysVol_Name("None");
-    if (targetPhysical!=0)
-    {
-      curPhysVol_Name = targetPhysical->GetName();
-    }
+    if (targetPhysical)  { curPhysVol_Name = targetPhysical->GetName(); }
     G4cout << "    Return value = new volume = " << curPhysVol_Name << G4endl;
     G4cout << "    ----- Upon exiting:" << G4endl;
@@ -465,6 +464,6 @@
     G4cout << "    History = " << G4endl << fHistory << G4endl << G4endl;
 #endif
-  }
-  G4cout.precision(oldcoutPrec);
+    G4cout.precision(oldcoutPrec);
+  }
 #endif
 
@@ -627,5 +626,5 @@
 {
   G4ThreeVector localDirection = ComputeLocalAxis(pDirection);
-  G4double Step = DBL_MAX;
+  G4double Step = kInfinity;
   G4VPhysicalVolume  *motherPhysical = fHistory.GetTopVolume();
   G4LogicalVolume *motherLogical = motherPhysical->GetLogicalVolume();
@@ -635,6 +634,4 @@
 
 #ifdef G4VERBOSE
-  G4int oldcoutPrec= G4cout.precision(8);
-  G4int oldcerrPrec= G4cerr.precision(10);
   if( fVerbose > 0 )
   {
@@ -654,7 +651,4 @@
 #endif
   }
-
-  static G4double fAccuracyForWarning   = kCarTolerance,
-                  fAccuracyForException = 1000*kCarTolerance;
 #endif
 
@@ -670,91 +664,6 @@
     {
 #ifdef G4VERBOSE
-      //  The following checks only make sense if the move is larger
-      //  than the tolerance.
-      // 
-      G4ThreeVector OriginalGlobalpoint =
-                    fHistory.GetTopTransform().Inverse().
-                    TransformPoint(fLastLocatedPointLocal); 
-
-      G4double shiftOriginSafSq = (fPreviousSftOrigin-pGlobalpoint).mag2();
-
-      // Check that the starting point of this step is 
-      // within the isotropic safety sphere of the last point
-      // to a accuracy/precision  given by fAccuracyForWarning.
-      //   If so give warning.
-      //   If it fails by more than fAccuracyForException exit with error.
-      //
-      if( shiftOriginSafSq >= sqr(fPreviousSafety) )
-      {
-        G4double shiftOrigin = std::sqrt(shiftOriginSafSq);
-        G4double diffShiftSaf = shiftOrigin - fPreviousSafety;
-
-        if( diffShiftSaf > fAccuracyForWarning )
-        {
-          G4Exception("G4Navigator::ComputeStep()",
-                      "UnexpectedPositionShift", JustWarning,
-                      "Accuracy ERROR or slightly inaccurate position shift.");
-          G4cerr << "     The Step's starting point has moved " 
-                 << std::sqrt(moveLenSq)/mm << " mm " << G4endl
-                 << "     since the last call to a Locate method." << G4endl;
-          G4cerr << "     This has resulted in moving " 
-                 << shiftOrigin/mm << " mm " 
-                 << " from the last point at which the safety " 
-                 << "     was calculated " << G4endl;
-          G4cerr << "     which is more than the computed safety= " 
-                 << fPreviousSafety/mm << " mm  at that point." << G4endl;
-          G4cerr << "     This difference is " 
-                 << diffShiftSaf/mm << " mm." << G4endl
-                 << "     The tolerated accuracy is "
-                 << fAccuracyForException/mm << " mm." << G4endl;
-
-          static G4int warnNow = 0;
-          if( ((++warnNow % 100) == 1) )
-          {
-            G4cerr << "  This problem can be due to either " << G4endl;
-            G4cerr << "    - a process that has proposed a displacement"
-                   << " larger than the current safety , or" << G4endl;
-            G4cerr << "    - inaccuracy in the computation of the safety"
-                   << G4endl;
-            G4cerr << "  We suggest that you " << G4endl
-                   << "   - find i) what particle is being tracked, and "
-                   << " ii) through what part of your geometry " << G4endl
-                   << "      for example by re-running this event with "
-                   << G4endl
-                   << "         /tracking/verbose 1 "  << G4endl
-                   << "    - check which processes you declare for"
-                   << " this particle (and look at non-standard ones)"
-                   << G4endl
-                   << "   - in case, create a detailed logfile"
-                   << " of this event using:" << G4endl
-                   << "         /tracking/verbose 6 "
-                   << G4endl;
-          }
-        }
-#ifdef G4DEBUG_NAVIGATION
-        else
-        {
-          G4cerr << "WARNING - G4Navigator::ComputeStep()" << G4endl
-                 << "          The Step's starting point has moved "
-                 << std::sqrt(moveLenSq) << "," << G4endl
-                 << "          which has taken it to the limit of"
-                 << " the current safety. " << G4endl;
-        }
-#endif
-      }
-      G4double safetyPlus = fPreviousSafety + fAccuracyForException;
-      if ( shiftOriginSafSq > sqr(safetyPlus) )
-      {
-        G4cerr << "ERROR - G4Navigator::ComputeStep()" << G4endl
-               << "        Position has shifted considerably without"
-               << " notifying the navigator !" << G4endl
-               << "        Tolerated safety: " << safetyPlus << G4endl
-               << "        Computed shift  : " << shiftOriginSafSq << G4endl;
-        G4Exception("G4Navigator::ComputeStep()",
-                    "SignificantPositionShift", JustWarning,
-                    "May lead to a crash or unreliable results.");
-      }
-#endif  // end G4VERBOSE
-
+      ComputeStepLog(pGlobalpoint, moveLenSq);
+#endif
       // Relocate the point within the same volume
       //
@@ -784,5 +693,5 @@
         else
         {
-          if( motherPhysical->GetRegularStructureId() != 1 )
+          if( motherPhysical->GetRegularStructureId() == 0 )
           {
             Step = fnormalNav.ComputeStep(fLastLocatedPointLocal,
@@ -811,5 +720,5 @@
             // reset the history topvolume to world.
             //
-            if(fHistory.GetTopVolume()->GetRegularStructureId() != 1 )
+            if(fHistory.GetTopVolume()->GetRegularStructureId() == 0 )
             { 
               G4Exception("G4Navigator::ComputeStep()",
@@ -944,7 +853,7 @@
        // Act to recover this stuck track. Pushing it along direction
        //
-       Step += 0.9*kCarTolerance;
+       Step += 100*kCarTolerance;
 #ifdef G4VERBOSE
-       if (!fPushed)
+       if ((!fPushed) && (fWarnPush))
        {
          G4cerr << "WARNING - G4Navigator::ComputeStep()" << G4endl
@@ -1048,6 +957,4 @@
     G4cout << "    Safety = " << pNewSafety << G4endl;
   }
-  G4cout.precision(oldcoutPrec);
-  G4cerr.precision(oldcerrPrec);
 #endif
 
@@ -1112,5 +1019,5 @@
   fBlockedReplicaNo      = -1;
 
-  fLastLocatedPointLocal = G4ThreeVector( DBL_MAX, -DBL_MAX, 0.0 ); 
+  fLastLocatedPointLocal = G4ThreeVector( kInfinity, -kInfinity, 0.0 ); 
   fLocatedOutsideWorld   = false;
 }
@@ -1132,5 +1039,4 @@
   G4VPVParameterisation *pParam;
 
-  mother = fHistory.GetVolume(0);
   for ( i=1; i<=cdepth; i++ )
   {
@@ -1408,4 +1314,104 @@
 
 // ********************************************************************
+// ComputeStepLog
+// ********************************************************************
+//
+void G4Navigator::ComputeStepLog(const G4ThreeVector& pGlobalpoint,
+                                       G4double moveLenSq) const
+{
+  //  The following checks only make sense if the move is larger
+  //  than the tolerance.
+
+  static const G4double fAccuracyForWarning   = kCarTolerance,
+                        fAccuracyForException = 1000*kCarTolerance;
+
+  G4ThreeVector OriginalGlobalpoint = fHistory.GetTopTransform().Inverse().
+                                      TransformPoint(fLastLocatedPointLocal); 
+
+  G4double shiftOriginSafSq = (fPreviousSftOrigin-pGlobalpoint).mag2();
+
+  // Check that the starting point of this step is 
+  // within the isotropic safety sphere of the last point
+  // to a accuracy/precision  given by fAccuracyForWarning.
+  //   If so give warning.
+  //   If it fails by more than fAccuracyForException exit with error.
+  //
+  if( shiftOriginSafSq >= sqr(fPreviousSafety) )
+  {
+    G4double shiftOrigin = std::sqrt(shiftOriginSafSq);
+    G4double diffShiftSaf = shiftOrigin - fPreviousSafety;
+
+    if( diffShiftSaf > fAccuracyForWarning )
+    {
+      G4int oldcoutPrec= G4cout.precision(8);
+      G4int oldcerrPrec= G4cerr.precision(10);
+      G4Exception("G4Navigator::ComputeStep()",
+                  "UnexpectedPositionShift", JustWarning,
+                  "Accuracy error or slightly inaccurate position shift.");
+      G4cerr << "     The Step's starting point has moved " 
+             << std::sqrt(moveLenSq)/mm << " mm " << G4endl
+             << "     since the last call to a Locate method." << G4endl;
+      G4cerr << "     This has resulted in moving " 
+             << shiftOrigin/mm << " mm " 
+             << " from the last point at which the safety " 
+             << "     was calculated " << G4endl;
+      G4cerr << "     which is more than the computed safety= " 
+             << fPreviousSafety/mm << " mm  at that point." << G4endl;
+      G4cerr << "     This difference is " 
+             << diffShiftSaf/mm << " mm." << G4endl
+             << "     The tolerated accuracy is "
+             << fAccuracyForException/mm << " mm." << G4endl;
+
+      static G4int warnNow = 0;
+      if( ((++warnNow % 100) == 1) )
+      {
+        G4cerr << "  This problem can be due to either " << G4endl;
+        G4cerr << "    - a process that has proposed a displacement"
+               << " larger than the current safety , or" << G4endl;
+        G4cerr << "    - inaccuracy in the computation of the safety"
+                   << G4endl;
+        G4cerr << "  We suggest that you " << G4endl
+               << "   - find i) what particle is being tracked, and "
+               << " ii) through what part of your geometry " << G4endl
+               << "      for example by re-running this event with "
+               << G4endl
+               << "         /tracking/verbose 1 "  << G4endl
+               << "    - check which processes you declare for"
+               << " this particle (and look at non-standard ones)"
+               << G4endl
+               << "   - in case, create a detailed logfile"
+               << " of this event using:" << G4endl
+               << "         /tracking/verbose 6 "
+               << G4endl;
+      }
+      G4cout.precision(oldcoutPrec);
+      G4cerr.precision(oldcerrPrec);
+    }
+#ifdef G4DEBUG_NAVIGATION
+    else
+    {
+      G4cerr << "WARNING - G4Navigator::ComputeStep()" << G4endl
+             << "          The Step's starting point has moved "
+             << std::sqrt(moveLenSq) << "," << G4endl
+             << "          which has taken it to the limit of"
+             << " the current safety. " << G4endl;
+    }
+#endif
+  }
+  G4double safetyPlus = fPreviousSafety + fAccuracyForException;
+  if ( shiftOriginSafSq > sqr(safetyPlus) )
+  {
+    G4cerr << "ERROR - G4Navigator::ComputeStep()" << G4endl
+           << "        Position has shifted considerably without"
+           << " notifying the navigator !" << G4endl
+           << "        Tolerated safety: " << safetyPlus << G4endl
+           << "        Computed shift  : " << shiftOriginSafSq << G4endl;
+    G4Exception("G4Navigator::ComputeStep()",
+                "SignificantPositionShift", JustWarning,
+                "May lead to a crash or unreliable results.");
+  }
+}
+
+// ********************************************************************
 // Operator <<
 // ********************************************************************
Index: trunk/source/geometry/navigation/src/G4NormalNavigation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4NormalNavigation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4NormalNavigation.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NormalNavigation.cc,v 1.9 2007/05/11 13:43:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NormalNavigation.cc,v 1.11 2010/11/04 08:57:56 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
@@ -38,6 +38,4 @@
 #include "G4AffineTransform.hh"
 
-#include <iomanip>
-
 // ********************************************************************
 // Constructor
@@ -45,6 +43,7 @@
 //
 G4NormalNavigation::G4NormalNavigation()
-  : fCheck(false), fVerbose(0)
-{
+  : fCheck(false)
+{
+  fLogger = new G4NavigationLogger("G4NormalNavigation");
 }
 
@@ -54,5 +53,7 @@
 //
 G4NormalNavigation::~G4NormalNavigation()
-{;}
+{
+  delete fLogger;
+}
 
 // ********************************************************************
@@ -90,70 +91,7 @@
   
 #ifdef G4VERBOSE
-  static G4int precVerf= 20;  // Precision 
   if ( fCheck )
   {
-    if( fVerbose == 1 )
-    {
-      G4cout << "*** G4NormalNavigation::ComputeStep(): ***" << G4endl
-             << "    Invoked DistanceToOut(p) for mother solid: "
-             << motherSolid->GetName()
-             << ". Solid replied: " << motherSafety << G4endl
-             << "    For local point p: " << localPoint << G4endl
-             << "    To be considered as 'mother safety'." << G4endl;
-    }
-    if ( motherSafety < 0.0 )
-    {
-      G4cerr << "ERROR - G4NormalNavigation::ComputeStep()" << G4endl
-             << "        Current solid " << motherSolid->GetName()
-             << " gave negative safety: " << motherSafety << G4endl
-             << "        for the current (local) point " << localPoint
-             << G4endl;
-      motherSolid->DumpInfo();
-      G4Exception("G4NormalNavigation::ComputeStep()",
-                  "NegativeSafetyMotherVol", FatalException,
-                  "Negative Safety In Voxel Navigation !" );
-    }
-    if( motherSolid->Inside(localPoint)==kOutside )
-    {
-      G4cout << "WARNING - G4NormalNavigation::ComputeStep()" << G4endl
-             << "          Point " << localPoint
-             << " is outside current volume " << motherPhysical->GetName()
-             << G4endl;
-      G4double estDistToSolid= motherSolid->DistanceToIn(localPoint); 
-      G4cout << "          Estimated isotropic distance to solid (distToIn)= " 
-             << estDistToSolid << G4endl;
-      if( estDistToSolid > 100.0 * motherSolid->GetTolerance() )
-      {
-        motherSolid->DumpInfo();
-        G4Exception("G4NormalNavigation::ComputeStep()",
-                    "FarOutsideCurrentVolume", FatalException,
-                    "Point is far outside Current Volume !" ); 
-      }
-      else
-        G4Exception("G4NormalNavigation::ComputeStep()", "OutsideCurrentVolume", 
-                    JustWarning, "Point is a little outside Current Volume."); 
-    }
-
-    // Verification / verbosity
-    //
-    if ( fVerbose > 1 )
-    {
-      G4int oldprec = G4cout.precision(precVerf);
-      G4cout << " G4NormalNavigation::ComputeStep()"
-             << " - Information on mother / key daughters ..." << G4endl;
-      G4cout << " Type   " << std::setw(12) << "Solid-Name"   << " " 
-             << std::setw(3*(6+precVerf))   << " local point" << " "
-             << std::setw(4+precVerf)       << "solid-Safety" << " "
-             << std::setw(4+precVerf)       << "solid-Step"   << " "
-             << std::setw(17)               << "distance Method "
-             << std::setw(3*(6+precVerf))   << " local direction" << " "
-             << G4endl;
-      G4cout << " Mother " << std::setw(12) << motherSolid->GetName() << " "
-             << std::setw(4+precVerf)       << localPoint   << " "
-             << std::setw(4+precVerf)       << motherSafety << " "
-             << G4endl;
-      G4cout.precision(oldprec);
-    }
-
+    fLogger->PreComputeStepLog(motherPhysical, motherSafety, localPoint);
   }
 #endif
@@ -193,4 +131,10 @@
       const G4double sampleSafety =
               sampleSolid->DistanceToIn(samplePoint);
+#ifdef G4VERBOSE
+      if( fCheck )
+      {
+        fLogger->PrintDaughterLog(sampleSolid, samplePoint, sampleSafety, 0);
+      }
+#endif
       if ( sampleSafety<ourSafety )
       {
@@ -202,14 +146,10 @@
         const G4double sampleStep =
                 sampleSolid->DistanceToIn(samplePoint,sampleDirection);
-#ifdef G4VERBOSE
-        if(( fCheck ) && ( fVerbose == 1 ))
+
+#ifdef G4VERBOSE
+        if( fCheck )
         {
-          G4cout << "*** G4NormalNavigation::ComputeStep(): ***" << G4endl
-                 << "    Invoked DistanceToIn(p,v) for daughter solid: "
-                 << sampleSolid->GetName()
-                 << ". Solid replied: " << sampleStep << G4endl
-                 << "    For local point p: " << samplePoint << G4endl
-                 << "    Direction v: " << sampleDirection
-                 << ", to be considered as 'daughter step'." << G4endl;
+          fLogger->PrintDaughterLog(sampleSolid, samplePoint,
+                                    sampleSafety, sampleStep);
         }
 #endif
@@ -221,67 +161,9 @@
           *pBlockedPhysical = samplePhysical;
           blockedReplicaNo  = -1;
-
-#ifdef G4VERBOSE
-          // Check to see that the resulting point is indeed in/on volume.
-          // This check could eventually be made only for successful candidate.
-
-          if ( ( fCheck ) && ( sampleStep < kInfinity ) )
+#ifdef G4VERBOSE
+          if( fCheck )
           {
-            G4ThreeVector intersectionPoint;
-            intersectionPoint= samplePoint + sampleStep * sampleDirection;
-            EInside insideIntPt= sampleSolid->Inside(intersectionPoint); 
-            G4String solidResponse = "-kInside-";
-            if (insideIntPt == kOutside)
-              solidResponse = "-kOutside-";
-            else if (insideIntPt == kSurface)
-              solidResponse = "-kSurface-";
-            if( fVerbose == 1 )
-            {
-              G4cout << "*** G4NormalNavigation::ComputeStep(): ***" << G4endl
-                     << "    Invoked Inside() for solid: "
-                     << sampleSolid->GetName()
-                     << ". Solid replied: " << solidResponse << G4endl
-                     << "    For point p: " << intersectionPoint
-                     << ", considered as 'intersection' point." << G4endl;
-            }
-            if ( insideIntPt != kSurface )
-            {
-              G4int oldcoutPrec = G4cout.precision(16); 
-              G4cout << "WARNING - G4NormalNavigation::ComputeStep()" << G4endl
-                     << "          Inaccurate DistanceToIn for solid "
-                     << sampleSolid->GetName() << G4endl;
-              G4cout << "          Solid gave DistanceToIn = " << sampleStep
-                     << " yet returns " << solidResponse
-                     << " for this point !" << G4endl; 
-              G4cout << "          Point = " << intersectionPoint << G4endl;
-              if ( insideIntPt != kInside )
-                G4cout << "        DistanceToIn(p) = " 
-                       << sampleSolid->DistanceToIn(intersectionPoint)
-                       << G4endl;
-              if ( insideIntPt != kOutside ) 
-                G4cout << "        DistanceToOut(p) = " 
-                       << sampleSolid->DistanceToOut(intersectionPoint)
-                       << G4endl;
-              G4Exception("G4NormalNavigation::ComputeStep()", 
-                          "InaccurateDistanceToIn", JustWarning,
-                          "Navigator gets conflicting response from Solid."); 
-              G4cout.precision(oldcoutPrec);
-            }
-          }
-
-          // Verification / verbosity
-          //
-          if ( fVerbose > 1 )
-          {
-            G4int oldprec = G4cout.precision(precVerf);
-            G4cout << " Daught "
-                   << std::setw(12)         << sampleSolid->GetName() << " "
-                   << std::setw(4+precVerf) << samplePoint  << " "
-                   << std::setw(4+precVerf) << sampleSafety << " "
-                   << std::setw(4+precVerf) << sampleStep   << " "
-                   << std::setw(16)         << "distanceToIn" << " "
-                   << std::setw(4+precVerf) << localDirection << " "
-                   << G4endl;
-            G4cout.precision(oldprec);
+            fLogger->AlongComputeStepLog(sampleSolid, samplePoint,
+              sampleDirection, localDirection, sampleSafety, sampleStep);
           }
 #endif
@@ -313,39 +195,6 @@
       if ( fCheck )
       {
-        if( fVerbose == 1 )
-        {
-          G4cout << "*** G4NormalNavigation::ComputeStep(): ***" << G4endl
-                 << "    Invoked DistanceToOut(p,v,...) for mother solid: "
-                 << motherSolid->GetName()
-                 << ". Solid replied: " << motherStep << G4endl
-                 << "    For local point p: " << localPoint << G4endl
-                 << "    Direction v: " << localDirection
-                 << ", to be considered as 'mother step'." << G4endl;
-        }
-        if( ( motherStep < 0.0 ) || ( motherStep >= kInfinity) )
-        {
-          G4cerr << "ERROR - G4NormalNavigation::ComputeStep()" << G4endl
-                 << "        Problem in Navigation"  << G4endl
-                 << "        Point (local coordinates): "
-                 << localPoint << G4endl
-                 << "        Local Direction: " << localDirection << G4endl
-                 << "        Solid: " << motherSolid->GetName() << G4endl; 
-          motherSolid->DumpInfo();
-          G4Exception("G4NormalNavigation::ComputeStep()",
-                      "PointDistOutInvalid", FatalException,
-                      "Current point is outside the current solid !");
-        }
-      }
-      if ( fVerbose > 1 )
-      {
-        G4int oldprec = G4cout.precision(precVerf);
-        G4cout << " Mother " << std::setw(12) << motherSolid->GetName() << " "
-               << std::setw(4+precVerf)       << localPoint   << " "
-               << std::setw(4+precVerf)       << motherSafety << " "
-               << std::setw(4+precVerf)       << motherStep   << " "
-               << std::setw(16)               << "distanceToOut" << " "
-               << std::setw(4+precVerf)       << localDirection << " "
-               << G4endl;
-        G4cout.precision(oldprec);      
+        fLogger->PostComputeStepLog(motherSolid, localPoint, localDirection,
+                                    motherStep, motherSafety);
       }
 #endif
@@ -399,12 +248,7 @@
 
 #ifdef G4VERBOSE
-  if(( fCheck ) && ( fVerbose == 1 ))
-  {
-    G4cout << "*** G4NormalNavigation::ComputeSafety(): ***" << G4endl
-           << "    Invoked DistanceToOut(p) for mother solid: "
-           << motherSolid->GetName()
-           << ". Solid replied: " << motherSafety << G4endl
-           << "    For local point p: " << localPoint
-           << ", to be considered as 'mother safety'." << G4endl;
+  if( fCheck )
+  {
+    fLogger->ComputeSafetyLog(motherSolid, localPoint, motherSafety, true);
   }
 #endif
@@ -430,12 +274,7 @@
     }
 #ifdef G4VERBOSE
-    if(( fCheck ) && ( fVerbose == 1 ))
-    {
-      G4cout << "*** G4NormalNavigation::ComputeSafety(): ***" << G4endl
-             << "    Invoked DistanceToIn(p) for daughter solid: "
-             << sampleSolid->GetName()
-             << ". Solid replied: " << sampleSafety << G4endl
-             << "    For local point p: " << samplePoint
-             << ", to be considered as 'daughter safety'." << G4endl;
+    if(fCheck)
+    {
+      fLogger->ComputeSafetyLog(sampleSolid, samplePoint, sampleSafety, false);
     }
 #endif
Index: trunk/source/geometry/navigation/src/G4ParameterisedNavigation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4ParameterisedNavigation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4ParameterisedNavigation.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ParameterisedNavigation.cc,v 1.12 2007/11/09 16:06:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4ParameterisedNavigation.cc,v 1.13 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
@@ -58,5 +58,6 @@
 //
 G4ParameterisedNavigation::G4ParameterisedNavigation()
-  : fVoxelHeader(0)
+  : fVoxelAxis(kUndefined), fVoxelNoSlices(0), fVoxelSliceWidth(0.),
+    fVoxelNodeNo(0), fVoxelHeader(0)
 {
 }
Index: trunk/source/geometry/navigation/src/G4PathFinder.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4PathFinder.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4PathFinder.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4PathFinder.cc,v 1.62 2009/05/13 23:20:54 japost Exp $
+// $Id: G4PathFinder.cc,v 1.64 2010/07/13 15:59:42 gcosmo Exp $
 // GEANT4 tag $ Name:  $
 // 
@@ -69,6 +69,7 @@
 G4PathFinder::G4PathFinder() 
   : fEndState( G4ThreeVector(), G4ThreeVector(), 0., 0., 0., 0., 0.),
+    fFieldExertedForce(false),
     fRelocatedPoint(true),
-    fLastStepNo(-1), 
+    fLastStepNo(-1), fCurrentStepNo(-1),
     fVerboseLevel(0)
 {
@@ -91,8 +92,10 @@
    fMinSafety_atSafLocation= -1.0; 
    fMinStep=   -1.0;
+   fTrueMinStep= -1.0;
+   fPreStepCenterRenewed= false;
    fNewTrack= false; 
    fNoGeometriesLimiting= 0; 
 
-   for( register int num=0; num<= fMaxNav; ++num )
+   for( register int num=0; num< fMaxNav; ++num )
    {
       fpNavigator[num] =  0;   
Index: trunk/source/geometry/navigation/src/G4PhantomParameterisation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4PhantomParameterisation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4PhantomParameterisation.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4PhantomParameterisation.cc,v 1.6 2009/05/20 08:27:10 gcosmo Exp $
+// $Id: G4PhantomParameterisation.cc,v 1.7 2010/07/13 15:59:42 gcosmo Exp $
 // GEANT4 tag $ Name:$
 //
@@ -45,15 +45,11 @@
 //------------------------------------------------------------------
 G4PhantomParameterisation::G4PhantomParameterisation()
-{
-  // Initialise data
-  //
-  fMaterialIndices = 0;
-  fContainerWallX = 0.;
-  fContainerWallY = 0.;
-  fContainerWallZ = 0.;
-
+  : fVoxelHalfX(0.), fVoxelHalfY(0.), fVoxelHalfZ(0.),
+    fNoVoxelX(0), fNoVoxelY(0), fNoVoxelZ(0), fNoVoxelXY(0), fNoVoxel(0),
+    fMaterialIndices(0), fContainerSolid(0),
+    fContainerWallX(0.), fContainerWallY(0.), fContainerWallZ(0.),
+    bSkipEqualMaterials(true)
+{
   kCarTolerance = G4GeometryTolerance::GetInstance()->GetSurfaceTolerance();
-
-  bSkipEqualMaterials = 1;
 }
 
